require 'etc'
require 'thor'
require "net/http"
require 'anamo/api'

module Anamo
  module Groups

    class Thor < ::Thor

      description = "Inspect the groups list and send the results"
      desc "groups exec", description
      long_desc description

      def exec

        data = inspect false
        response = ::Anamo::Api.new.post_groups data

      end

      description = "Inspect the groups list"
      desc "groups inspect", description
      long_desc description

      def inspect output = true

        un_to_uid = {};
        gids_from_passwd = {}
        Etc.passwd do |u|
          un_to_uid[u.name] = u.uid
          gids_from_passwd[u.gid] = [] unless gids_from_passwd.has_key? u.gid
          gids_from_passwd[u.gid] << u.uid unless gids_from_passwd[u.gid].include? u.uid
        end

        ret = CSV.generate do |csv|
          Etc.group do |g|
            uids_in_group = g.mem.map { |un| un_to_uid[un] }
            uids_in_group += gids_from_passwd[g.gid] if gids_from_passwd.has_key? g.gid
            csv << [g.gid, g.name, "[#{uids_in_group.uniq.join(',')}]"]
          end
        end

        puts ret if output

        ret

      end

    end
  end
end
