require 'anamo/thor'
require 'yaml'

if ARGV[0]
  path = ARGV[0]
else
  path = "#{Dir.home}/anamo.conf.yml"
end

config = YAML.load_file(path)

unless config.has_key? 'modules'
  config['modules'] = {
    'node' => {
      'frequency' => 60
    },
    'fstree' => {
      'frequency' => 240,
      'paths' => {
        '/' => 4
      },
      'exclude' => [
        '/proc',
        '/tmp',
        '/dev',
        '/run'
      ]
    },
    'pkgver' => {
      'frequency' => 60
    },
    'ports' => {
      'frequency' => 60
    }
  }
end

minutes_running = 0

Dir.chdir(File.dirname File.dirname __FILE__) do

  # initial node setup
  cmd = ::Anamo::Node::Thor.new
  cmd.options = {}
  cmd.exec

  loop do

    if config.has_key?('modules') and config['modules'].has_key?('node')

      frequency = config['modules']['node'].has_key?('frequency') ? config['modules']['node']['frequency'] : 30

      if minutes_running % frequency == 0

        begin

          cmd = ::Anamo::Node::Thor.new
          cmd.options = {}
          cmd.exec

        rescue; end

      end

    end

    if config.has_key?('modules') and config['modules'].has_key?('fstree')

      frequency = config['modules']['fstree'].has_key?('frequency') ? config['modules']['fstree']['frequency'] : 30

      if minutes_running % frequency == 0

        begin

          cmd = ::Anamo::Groups::Thor.new
          cmd.options = {}
          cmd.exec

          cmd = ::Anamo::Users::Thor.new
          cmd.options = {}
          cmd.exec

          cmd = ::Anamo::Fstree::Thor.new
          cmd.options = {}
          cmd.set_paths(config['modules']['fstree']['paths']) if config['modules']['fstree'].has_key?('paths')
          cmd.set_exclusions(config['modules']['fstree']['exclude']) if config['modules']['fstree'].has_key?('exclude')
          cmd.exec

        rescue; end

      end

    end

    if config.has_key?('modules') and config['modules'].has_key?('pkgver')

      frequency = config['modules']['pkgver'].has_key?('frequency') ? config['modules']['pkgver']['frequency'] : 30

      if minutes_running % frequency == 0

        begin

          cmd = ::Anamo::Pkgver::Thor.new
          cmd.options = {}
          cmd.exec

        rescue; end

      end

    end

    if config.has_key?('modules') and config['modules'].has_key?('ports')

      frequency = config['modules']['ports'].has_key?('frequency') ? config['modules']['ports']['frequency'] : 30

      if minutes_running % frequency == 0

        begin

          cmd = ::Anamo::Ports::Thor.new
          cmd.options = {}
          cmd.exec

        rescue; end

      end

    end

    minutes_running = minutes_running + 1
    sleep 60 # wait one minute

  end

end
