require 'etc'
require 'thor'
require 'csv'
require 'anamo/api'

module Anamo
  module Users

    class Thor < ::Thor

      description = "Inspect the user list and send the results"
      desc "users exec", description
      long_desc description

      def exec

        data = inspect false
        ::Anamo::Api.new.post_users data

      end

      description = "Inspect the user list"
      desc "users inspect", description
      long_desc description

      def inspect output = true

        ret = CSV.generate do |csv|
          Etc.passwd do |u|
            csv << [u.uid, u.gid, u.name, u.gecos, u.dir, u.shell]
          end
        end

        puts ret if output

        ret

      end

    end
  end
end
